<?php
  /**
   ** read_body.php
   **
   **  Copyright (c) 1999-2000 The SquirrelMail development team
   **  Licensed under the GNU GPL. For full terms see the file COPYING.
   **
   **  This file is used for reading the msgs array and displaying
   **  the resulting emails in the right frame.
   **/

   session_start();

   if (!isset($config_php))
      include("../config/config.php");
   if (!isset($strings_php))
      include("../functions/strings.php");
   if (!isset($page_header_php))
      include("../functions/page_header.php");
   if (!isset($imap_php))
      include("../functions/imap.php");
   if (!isset($mime_php))
      include("../functions/mime.php");
   if (!isset($date_php))
      include("../functions/date.php");
	if (!isset($url_parser_php)) 
		include("../functions/url_parser.php");

   include("../src/load_prefs.php");
   $imapConnection = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);
   sqimap_mailbox_select($imapConnection, $mailbox);
   do_hook("html_top");
   displayPageHeader($color, $mailbox);

   if ($view_hdr) {
      fputs ($imapConnection, "a003 FETCH $passed_id BODY[HEADER]\r\n");
      $read = sqimap_read_data ($imapConnection, "a003", true, $a, $b); 
      
      echo "<br>";
      echo "<table width=100% cellpadding=2 cellspacing=0 border=0 align=center>\n";
      echo "   <TR><TD BGCOLOR=\"$color[9]\" WIDTH=100%><center><b>" . _("Viewing full header") . "</b> - ";
      if ($where && $what) {
         // Got here from a search
         echo "<a href=\"read_body.php?mailbox=".urlencode($mailbox)."&passed_id=$passed_id&where=".urlencode($where)."&what=".urlencode($what)."\">";
      } else {
         echo "<a href=\"read_body.php?mailbox=".urlencode($mailbox)."&passed_id=$passed_id&startMessage=$startMessage&show_more=$show_more\">";
      }
      echo ""._("View message") . "</a></b></center></td></tr></table>\n";
      echo "<table width=99% cellpadding=2 cellspacing=0 border=0 align=center>\n";
      echo "<tr><td>";

      for ($i=1; $i < count($read)-1; $i++) {
         $line = htmlspecialchars($read[$i]);
			if (eregi("^&gt;", $line)) {
				$second[$i] = $line;
				$first[$i] = "&nbsp;";
				$cnum++;
         } else if (eregi("^[ |\t]", $line)) {
            $second[$i] = $line;
            $first[$i] = "";
         } else if (eregi("^([^:]+):(.+)", $line, $regs)) {
            $first[$i] = $regs[1] . ":";
            $second[$i] = $regs[2];
				$cnum++;
         } else {
            $second[$i] = trim($line);
            $first[$i] = "";
         }
		}
		for ($i=0; $i < count($second); $i = $j) {
			$f = $first[$i];
			$s = nl2br($second[$i]);
			$j = $i + 1;
			while ($first[$j] == "" && $j < count($first)) {
				$s .= "&nbsp;&nbsp;&nbsp;&nbsp;" . nl2br($second[$j]);
				$j++;
			}
			parseEmail($s);
			echo "<nobr><tt><b>$f</b>$s</tt></nobr>";
      }
      echo "</td></tr></table>\n";
      echo "</body></html>";
      sqimap_logout($imapConnection);
      exit;
   }

   // given an IMAP message id number, this will look it up in the cached and sorted msgs array and
   //    return the index.  used for finding the next and previous messages

   // returns the index of the next valid message from the array
   function findNextMessage() {
      global $msort, $currentArrayIndex, $msgs, $sort;

      if ($sort == 6) {
         if ($currentArrayIndex != 1) {
            return $currentArrayIndex - 1;
         }
      } else {
         for (reset($msort); ($key = key($msort)), (isset($key)); next($msort)) { 
            if ($currentArrayIndex == $msgs[$key]["ID"]) {
               next($msort); 
               $key = key($msort);
               if (isset($key)) 
                  return $msgs[$key]["ID"];
            }
         }
      }
      return -1;
   }

   // returns the index of the previous message from the array
   function findPreviousMessage() {
      global $msort, $currentArrayIndex, $sort, $msgs, $imapConnection, $mailbox;
      if ($sort == 6) {
         $numMessages = sqimap_get_num_messages($imapConnection, $mailbox);
         if ($currentArrayIndex != $numMessages) {
            return $currentArrayIndex + 1; 
         }
      } else {
   		for (reset($msort); ($key = key($msort)), (isset($key)); next($msort)) { 
      	   if ($currentArrayIndex == $msgs[$key]["ID"]) {
   				prev($msort);
   				$key = key($msort);
   				if (isset($key))
   					return $msgs[$key]["ID"];
   			}
   		}
      }   
      return -1;
   }

   if (isset($msgs)) {
	   $currentArrayIndex = $passed_id;
		/*
      for ($i=0; $i < count($msgs); $i++) {
         if ($msgs[$i]["ID"] == $passed_id) {
            $currentArrayIndex = $i;
            break;
         }
      }
		*/
   } else {
      $currentArrayIndex = -1;
   }

	for ($i = 0; $i < count($msgs); $i++) {
		if ($msgs[$i]["ID"] == $passed_id)
			$msgs[$i]["FLAG_SEEN"] = true;
	}

   // $message contains all information about the message
   // including header and body
   $message = sqimap_get_message($imapConnection, $passed_id, $mailbox);

   /** translate the subject and mailbox into url-able text **/
   $url_subj = urlencode(trim(sqStripSlashes($message->header->subject)));
   $urlMailbox = urlencode($mailbox);
   $url_replyto = urlencode($message->header->replyto);

   $url_replytoall   = urlencode($message->header->replyto);
   $url_replytoallcc = getLineOfAddrs($message->header->to);
   $url_replytoallcc_cc = getLineOfAddrs($message->header->cc);
   if ($url_replytoallcc) {
      if ($url_replytoallcc_cc) {
         $url_replytoallcc .= ", " . $url_replytoallcc_cc;
      }
   } else {
      if ($url_replytoallcc_cc) {
         $url_replytoallcc = $url_replytoallcc_cc;
      } else {
         $url_replytoallcc = "";
      }
   } 
   $url_replytoallcc = urlencode($url_replytoallcc);

   $dateString = getLongDateString($message->header->date);
   $ent_num = findDisplayEntity($message);

   /** TEXT STRINGS DEFINITIONS **/
   $echo_more = _("more");
   $echo_less = _("less");

   /** FORMAT THE TO STRING **/
   $i = 0;
   $to_string = "";
   $to_ary = $message->header->to;
   while ($i < count($to_ary)) {
      $to_ary[$i] = htmlspecialchars(decodeHeader($to_ary[$i]));

      if ($to_string)
         $to_string = "$to_string<BR>$to_ary[$i]";
      else
         $to_string = "$to_ary[$i]";

      $i++;
      if (count($to_ary) > 1) {
         if ($show_more == false) {
            if ($i == 1) {
               if ($where && $what) {
                  // from a search
                  $to_string = "$to_string&nbsp;(<A HREF=\"read_body.php?mailbox=$urlMailbox&passed_id=$passed_id&where=".urlencode($where)."&what=".urlencode($what)."&show_more=1&show_more_cc=$show_more_cc\">$echo_more</A>)";
               } else {
                  $to_string = "$to_string&nbsp;(<A HREF=\"read_body.php?mailbox=$urlMailbox&passed_id=$passed_id&sort=$sort&startMessage=$startMessage&show_more=1&show_more_cc=$show_more_cc\">$echo_more</A>)";
               }   
               $i = count($to_ary);
            }
         } else if ($i == 1) {
            if ($where && $what) {
               // from a search
               $to_string = "$to_string&nbsp;(<A HREF=\"read_body.php?mailbox=$urlMailbox&passed_id=$passed_id&where=".urlencode($where)."&what=".urlencode($what)."&show_more=0&show_more_cc=$show_more_cc\">$echo_less</A>)";
            } else {
               $to_string = "$to_string&nbsp;(<A HREF=\"read_body.php?mailbox=$urlMailbox&passed_id=$passed_id&sort=$sort&startMessage=$startMessage&show_more=0&show_more_cc=$show_more_cc\">$echo_less</A>)";
            }
         }
      }
   }

   /** FORMAT THE CC STRING **/
   $i = 0;
   $cc_string = "";
   $cc_ary = $message->header->cc;
   while ($i < count(decodeHeader($cc_ary))) {
      $cc_ary[$i] = htmlspecialchars($cc_ary[$i]);
      if ($cc_string)
         $cc_string = "$cc_string<BR>$cc_ary[$i]";
      else
         $cc_string = "$cc_ary[$i]";

      $i++;
      if (count($cc_ary) > 1) {
         if ($show_more_cc == false) {
            if ($i == 1) {
               if ($where && $what) {
                  // from a search
                  $cc_string = "$cc_string&nbsp;(<A HREF=\"read_body.php?mailbox=$urlMailbox&passed_id=$passed_id&what=".urlencode($what)."&where=".urlencode($where)."&show_more_cc=1&show_more=$show_more\">$echo_more</A>)";
               } else {
                  $cc_string = "$cc_string&nbsp;(<A HREF=\"read_body.php?mailbox=$urlMailbox&passed_id=$passed_id&sort=$sort&startMessage=$startMessage&show_more_cc=1&show_more=$show_more\">$echo_more</A>)";
               }   
               $i = count($cc_ary);
            }
         } else if ($i == 1) {
            if ($where && $what) {
               // from a search
               $cc_string = "$cc_string&nbsp;(<A HREF=\"read_body.php?mailbox=$urlMailbox&passed_id=$passed_id&what=".urlencode($what)."&where=".urlencode($where)."&show_more_cc=0&show_more=$show_more\">$echo_less</A>)";
            } else {
               $cc_string = "$cc_string&nbsp;(<A HREF=\"read_body.php?mailbox=$urlMailbox&passed_id=$passed_id&sort=$sort&startMessage=$startMessage&show_more_cc=0&show_more=$show_more\">$echo_less</A>)";
            }   
         }
      }
   }

   /** make sure everything will display in HTML format **/
   $from_name = decodeHeader(htmlspecialchars($message->header->from));
   $subject = decodeHeader(htmlspecialchars($message->header->subject));

   do_hook("read_body_top");
   echo "<BR>";

   echo "<TABLE COLS=1 CELLSPACING=0 WIDTH=100% BORDER=0 ALIGN=CENTER CELLPADDING=0>\n";
   echo "   <TR><TD BGCOLOR=\"$color[9]\" WIDTH=100%>";
   echo "      <TABLE WIDTH=100% CELLSPACING=0 BORDER=0 COLS=2 CELLPADDING=3>";
   echo "         <TR>";
   echo "            <TD ALIGN=LEFT WIDTH=33%>";
   echo "               <SMALL>";
   if ($where && $what) {
      echo "               <A HREF=\"search.php?where=".urlencode($where)."&what=".urlencode($what)."&mailbox=$urlMailbox\">";
   } else {
      echo "               <A HREF=\"right_main.php?use_mailbox_cache=1&sort=$sort&startMessage=$startMessage&mailbox=$urlMailbox\">";
   }
   echo _("Message List");
   echo "</A>&nbsp;|&nbsp;";
   if ($where && $what) {
      echo "               <A HREF=\"delete_message.php?mailbox=$urlMailbox&message=$passed_id&where=".urlencode($where)."&what=".urlencode($what)."\">";
   } else {
      echo "               <A HREF=\"delete_message.php?mailbox=$urlMailbox&message=$passed_id&sort=$sort&startMessage=$startMessage\">";
   }
   echo _("Delete");
   echo "</A>&nbsp;&nbsp;";
   echo "               </SMALL>";
   echo "            </TD><TD WIDTH=33% ALIGN=CENTER>";
   echo "               <SMALL>\n";
   if ($where && $what) {
   } else {
      if ($currentArrayIndex == -1) {
         echo "Previous&nbsp;|&nbsp;Next";
      } else {
         $prev = findPreviousMessage();
         $next = findNextMessage();
         if ($prev != -1)
            echo "<a href=\"read_body.php?passed_id=$prev&mailbox=$urlMailbox&sort=$sort&startMessage=$startMessage&show_more=0\">" . _("Previous") . "</A>&nbsp;|&nbsp;";
         else
            echo _("Previous") . "&nbsp;|&nbsp;";
         if ($next != -1)
            echo "<a href=\"read_body.php?passed_id=$next&mailbox=$urlMailbox&sort=$sort&startMessage=$startMessage&show_more=0\">" . _("Next") . "</A>";
         else
            echo _("Next");
      }
   }   
   echo "               </SMALL>\n";
   echo "            </TD><TD WIDTH=33% ALIGN=RIGHT>";
   echo "               <SMALL>";
   echo "               <A HREF=\"compose.php?forward_id=$passed_id&forward_subj=$url_subj&mailbox=$urlMailbox&ent_num=$ent_num\">";
   echo _("Forward");
   echo "</A>&nbsp;|&nbsp;";
   echo "               <A HREF=\"compose.php?send_to=$url_replyto&reply_subj=$url_subj&reply_id=$passed_id&mailbox=$urlMailbox&ent_num=$ent_num\">";
   echo _("Reply");
   echo "</A>&nbsp;|&nbsp;";
   echo "               <A HREF=\"compose.php?send_to=$url_replytoall&send_to_cc=$url_replytoallcc&reply_subj=$url_subj&reply_id=$passed_id&mailbox=$urlMailbox&ent_num=$ent_num\">";
   echo _("Reply All");
   echo "</A>&nbsp;&nbsp;";
   echo "               </SMALL>";
   echo "            </TD>";
   echo "         </TR>";
   echo "      </TABLE>";
   echo "   </TD></TR>";
   echo "   <TR><TD CELLSPACING=0 WIDTH=100%>";
   echo "   <TABLE COLS=2 WIDTH=100% BORDER=0 CELLSPACING=0 CELLPADDING=3>\n";
   echo "      <TR>\n";
   /** subject **/
   echo "         <TD BGCOLOR=\"$color[0]\" WIDTH=15% ALIGN=RIGHT>\n";
   echo _("Subject:");
   echo "         </TD><TD BGCOLOR=\"$color[0]\" WIDTH=84%>\n";
   echo "            <B>$subject</B>&nbsp;\n";
   echo "         </TD>\n";
   if ($where && $what) {
      // Got here from a search
      echo "         <TD WIDTH=1% bgcolor=\"$color[0]\" nowrap align=right><small><a href=\"read_body.php?mailbox=$urlMailbox&passed_id=$passed_id&where=".urlencode($where)."&what=".urlencode($what)."&view_hdr=1\">" . _("View full header") . "</a></small>&nbsp;&nbsp;</td>";
   } else {   
      echo "         <TD WIDTH=1% bgcolor=\"$color[0]\" nowrap align=right><small><a href=\"read_body.php?mailbox=$urlMailbox&passed_id=$passed_id&startMessage=$startMessage&show_more=$show_more&view_hdr=1\">" . _("View full header") . "</a></small>&nbsp;&nbsp;</td>";
   }
   echo "      </TR>\n";
   /** from **/
   echo "      <TR>\n";
   echo "         <TD BGCOLOR=\"$color[0]\" WIDTH=15% ALIGN=RIGHT>\n";
   echo _("From:");
   echo "         </TD><TD BGCOLOR=\"$color[0]\" WIDTH=85% colspan=2>\n";
   echo "            <B>$from_name</B>&nbsp;\n";
   echo "         </TD>\n";
   echo "      </TR>\n";
   /** date **/
   echo "      <TR>\n";
   echo "         <TD BGCOLOR=\"$color[0]\" WIDTH=15% ALIGN=RIGHT>\n";
   echo _("Date:");
   echo "         </TD><TD BGCOLOR=\"$color[0]\" WIDTH=85% colspan=2>\n";
   echo "            <B>$dateString</B>&nbsp;\n";
   echo "         </TD>\n";
   echo "      </TR>\n";
   /** to **/
   echo "      <TR>\n";
   echo "         <TD BGCOLOR=\"$color[0]\" WIDTH=15% ALIGN=RIGHT VALIGN=TOP>\n";
   echo _("To:");
   echo "         </TD><TD BGCOLOR=\"$color[0]\" WIDTH=85% VALIGN=TOP colspan=2>\n";
   echo "            <B>$to_string</B>&nbsp;\n";
   echo "         </TD>\n";
   echo "      </TR>\n";
   /** cc **/
   if ($message->header->cc) {
      echo "      <TR>\n";
      echo "         <TD BGCOLOR=\"$color[0]\" WIDTH=15% ALIGN=RIGHT VALIGN=TOP>\n";
      echo "            Cc:\n";
      echo "         </TD><TD BGCOLOR=\"$color[0]\" WIDTH=85% VALIGN=TOP colspan=2>\n";
      echo "            <B>$cc_string</B>&nbsp;\n";
      echo "         </TD>\n";
      echo "      </TR>\n";
   }
   echo "</TABLE>";
   echo "   </TD></TR>";
   echo "</table>";
   echo "<TABLE COLS=1 CELLSPACING=0 WIDTH=97% BORDER=0 ALIGN=CENTER CELLPADDING=0>\n";

   echo "   <TR><TD BGCOLOR=\"$color[4]\" WIDTH=100%>\n";
   echo "<BR>";
   
   $body = formatBody($imapConnection, $message, $color, $wrap_at);

   echo $body;
   
   echo "<TABLE COLS=1 CELLSPACING=0 WIDTH=100% BORDER=0 ALIGN=CENTER CELLPADDING=0>\n";
   echo "   <TR><TD BGCOLOR=\"$color[9]\">&nbsp;</TD></TR>";
   echo "</TABLE>\n";

   do_hook("read_body_bottom");
   do_hook("html_bottom");
   sqimap_logout($imapConnection);
?>
